local project_tbl, IsDeclared, scan_sector= ...

local IN_GAME = false

local function attach_display_container()
	iup.Append(iup.GetNextChild(HUD.cboxlayer), project_tbl.display_container)
	HUD.cboxlayer:map()
	HUD.cboxlayer.REFRESH = "YES"
end

project_tbl.Events = {
	["HUD_SHOW"] = function(_, event, data)
		scan_sector()
	end,
	
	["HUD_HIDE"] = function(_, event, data)
		project_tbl.refresh_timer:Kill()
	end,
	
	["TARGET_CHANGED"] = function(_, event, data)
		if (project_tbl.current_target_listindex) then project_tbl.display[project_tbl.current_target_listindex + 1][1].bgcolor = "0 0 0 0 *" end
		project_tbl.current_target_nodeid, project_tbl.current_target_objectid = radar.GetRadarSelectionID()
		project_tbl.current_target_listindex = nil
		for i, v in ipairs(project_tbl.shiplist) do
			if (i > project_tbl.list_count) then break end
			if (v.nodeid == project_tbl.current_target_nodeid) then
				project_tbl.display[i+1][1].bgcolor = project_tbl.current_target_color
				project_tbl.current_target_listindex = i
				break
			end
		end
	end,
	
	["PLAYER_ENTERED_GAME"] = function(_, event, data)
		if (not project_tbl.hasmdi) then
			attach_display_container()
			project_tbl:CreateRegions()
		end
		IN_GAME = true
	end,
	
	["PLAYER_LOGGED_OUT"] = function(_, event, data)
		if (not project_tbl.hasmdi) then
			iup.Detach(project_tbl.display_container)
			project_tbl:DestroyRegions()
		end
		IN_GAME = false
	end,
	
	["PLUGINS_LOADED"] = function(_, event, data)
		project_tbl:BuildDisplay()
		project_tbl.hasmdi = IsDeclared("mdi")
		if (project_tbl.hasmdi) then
-- 			local contextmenu = {{
-- 				title = function()
-- 					if (project_tbl.pc_only) then return "Show NPCs" end
-- 					return "Hide NPCs"
-- 				end,
-- 				action = togglepconly,
-- 			}}
			mdi:CreateWindow(project_tbl.id, project_tbl.display_container, {title = "Target List", cx = 350, cy = 350}) --, contextmenu)
		else
			project_tbl.display_container.cx = project_tbl.x
			project_tbl.display_container.cy = project_tbl.y
		end
		project_tbl.Events.TARGET_CHANGED()
	end,
	
	["rHUDxscale"] = function(_, event, data)
		if (not IN_GAME) then return end
		local timer = Timer()
		timer:SetTimeout(1, function() 
			if (not project_tbl.hasmdi) then
				project_tbl:BuildDisplay()
				attach_display_container()
				project_tbl.display[1][2][3][1][2].visible = "NO" -- Re-hide the progressbar in the header
				project_tbl:DestroyRegions()
				project_tbl:CreateRegions()
			end
		end)
	end,
	
	["UNLOAD_INTERFACE"] = function(_, event, data)
		project_tbl:DestroyRegions()
	end,
}

RegisterEvent(project_tbl.Events, "HUD_SHOW")
RegisterEvent(project_tbl.Events, "HUD_HIDE")
RegisterEvent(project_tbl.Events, "PLAYER_ENTERED_GAME")
RegisterEvent(project_tbl.Events, "PLAYER_LOGGED_OUT")
RegisterEvent(project_tbl.Events, "PLUGINS_LOADED")
RegisterEvent(project_tbl.Events, "TARGET_CHANGED")
RegisterEvent(project_tbl.Events, "rHUDxscale")
RegisterEvent(project_tbl.Events, "UNLOAD_INTERFACE")
